/**
FZI Forschungszentrum Informatik, Karlsruhe
mtrifu@fzi.de
*/

SELECT 
	types.fullname as class_name,
	files.pathname AS file_name,
	sourceEntities.startLine as line_number
FROM 
	TTypes types join
	TModelElements m on (types.id = m.id) join
	TConstants cm on (cm.value = m.status and cm.name = 'STATUS_NORMAL') join	
	TFunctions functions on (types.id = functions.classid) join
	TSignatures sig on (sig.functionid = functions.id) join
	TSourceEntities sourceEntities on (types.id = sourceEntities.id) join
	TFiles files on (sourceEntities.sourcefileid = files.id) join
	TAccesses returnaccess on (functions.returntypedeclarationid = returnaccess.id) join
	TTypes returnType on (returnaccess.targetid = returnType.id)
WHERE	
	(sig.signature = 'equals(java.lang.Object)' AND
	returnType.name = 'boolean') 
	OR
	(sig.signature = 'hashCode()' AND
	returnType.name = 'int')

EXCEPT

SELECT
	types.fullname as class_name,
	files.pathname AS file_name,
	sourceEntities.startLine as line_number
FROM 
	TTypes types join
	TFunctions meth1 on (types.id = meth1.classid) join
	TSignatures sig1 on (sig1.functionid = meth1.id) join
	TAccesses returnaccess1 on (meth1.returntypedeclarationid = returnaccess1.id) join
	TTypes returnType1 on (returnaccess1.targetid = returnType1.id) join
	TFunctions meth2 on (types.id = meth2.classid) join
	TSignatures sig2 on (sig2.functionid = meth2.id) join
	TAccesses returnaccess2 on (meth2.returntypedeclarationid = returnaccess2.id) join
	TTypes returnType2 on (returnaccess2.targetid = returnType2.id) join
	TSourceEntities sourceEntities on (types.id = sourceEntities.id) join
	TFiles files on (sourceEntities.sourcefileid = files.id) 

WHERE 
	sig1.signature = 'equals(java.lang.Object)' 
	AND returnType1.name = 'boolean'
	AND sig2.signature = 'hashCode()'
	AND returnType2.name = 'int'
;
